/*global define, CKEDITOR, setTimeout, document*/
/*jslint vars: true*/
define([
    'ep/ui/editor',
    'testsuite/qunit',
    'jquery',
    'testsuite/qunit-fixture!ckeditor/plugins/epcolorbutton/plugin-test',

    '$ready!'
    ], function (ep, QUnit, $, fixture) {

    'use strict';

    QUnit.module("ckeditor/plugins/epcolorbutton", {
        teardown: fixture.destroy
    });

    QUnit.fixtureVar = fixture;

    function selectElementById (id, editorInstance) {

        editorInstance.getSelection().selectElement(editorInstance.document.getById(id));
        return;
    }

    function cke_test(instance, openselector, closeselector, setfunction, testfunction, after) {
        $(openselector).trigger('click');
        setTimeout(function () {
            setfunction();
            setTimeout(function () {
                $(closeselector).trigger('click');
                setTimeout(function () {
                    var data = instance.getData();
                    testfunction(data);
                    setTimeout(after, 200);
                }, 500);
            }, 500);
        }, 500);
    }

    QUnit.asyncTest("text background test", function () {

/*---------clean elements after fixture to remove possible remains of almostFullScreen mode of the editor.------------*/
        $('#qunit-fixture').nextAll().remove();


        setTimeout(function () {
            QUnit.fixtureVar.init();
            ep('#uieditor_ckeditortestinstance').uiEditor({
                'name': 'ckeditortestinstance',
                'toolbar': 'FullPageBreak'
            });

            setTimeout(function () {
                var editor = CKEDITOR.instances.uieditor_ckeditortestinstance;
                var input = '<p id="foobar">foobar</p>';
                editor.setData(input);
                $('.cke_button__epalmostfullscreen_icon').trigger('click');
                setTimeout(function () {
                    var fullscreeneditor = CKEDITOR.instances.editor1;

                    selectElementById('foobar', fullscreeneditor);

                    cke_test(fullscreeneditor,
                        '.cke_button__epbgcolor_icon', '.ep-uiColorpicker-applyButton',
                        function () {
                            QUnit.ok(
                                $('.ep-colorpicker:visible').length === 1,
                                'Colorpicker is visible'
                            );
                            $('.ep-uiColorpicker-hexInput').val('black').trigger('change');
                        },
                        function (data) {
                            var elem = $(fullscreeneditor.getData());
                            var backgroundColor = elem.find('span').css('background-color');
                            if (backgroundColor === 'rgb(0, 0, 0)') {
                                backgroundColor = 'black';
                            }
                            QUnit.equal(
                                backgroundColor,
                                'black',
                                'Background color is black'
                            );
                            QUnit.ok(
                                $('.ep-colorpicker:visible').length === 0,
                                'Colorpicker is not visible'
                            );

                            $('.cke_button__epalmostfullscreenclose_icon').trigger('click');
                        },
                        function () {
                            ep('#uieditor_ckeditortestinstance').uiEditor('destroy');
                            setTimeout(function () {
                                QUnit.start();
                            }, 500);
                        });

                }, 2000);
            }, 2000);
        }, 1000);
    });

    QUnit.asyncTest("text color test", function () {
        QUnit.fixtureVar.init();
        setTimeout(function () {
            $('#qunit-fixture').nextAll().remove();
            ep('#uieditor_ckeditortestinstance').uiEditor({
                'name': 'ckeditortestinstance',
                'toolbar': 'FullPageBreak'
            });

            setTimeout(function () {
                var editor = CKEDITOR.instances.uieditor_ckeditortestinstance;
                var input = '<p id="foobar">foobar</p>';
                editor.setData(input);
                setTimeout(function () {

                    selectElementById('foobar', editor);

                    setTimeout(function () {
                        cke_test(CKEDITOR.instances.uieditor_ckeditortestinstance,
                            '.cke_button__eptextcolor_icon', '.ep-uiColorpicker-applyButton',
                            function () {
                                QUnit.ok(
                                    $('.ep-colorpicker:visible').length === 1,
                                    'Colorpicker is visible'
                                );

                                $('.ep-uiColorpicker-hexInput').val('red').trigger('change');
                            },
                            function (data) {
                                var elem = $(editor.getData());
                                var fontColor = elem.find('span').css('color');
                                if (fontColor === 'rgb(255, 0, 0)') {
                                    fontColor = 'red';
                                }
                                QUnit.equal(
                                    fontColor,
                                    'red',
                                    'Textcolor is red'
                                );
                                QUnit.ok(
                                    $('.ep-colorpicker:visible').length === 0,
                                    'Colorpicker is not visible'
                                );
                            },
                            function () {
                                ep('#uieditor_ckeditortestinstance').uiEditor('destroy');
                                QUnit.start();
                            });
                    }, 2000);
                }, 2000);
            }, 1000);
        }, 1000);
    });

});