define("de_epages/molliepayments/ui/checkoutconfirmation", [
    "jquery",
    "de_epages/molliepayments/ui/checkoutconfirmationhelper",
    "ep/ajax",
    "ep/fn/busy",
    'ep/ui/validate',
    "$ready!"
], function ($, checkoutconfirmationhelper, ep) {

    return function(
        BasketId,
        options
    ){
        var BasketForm,
            BuyButton,
            IsMobile = options.IsMobile,
            checkoutHelperObj;

        if ( IsMobile ) {
            BasketForm = ep('form#BasketOfferForm');
            BuyButton = ep("div.OrderProcessNavigation button[type=submit]");

            $('#AcceptTAC').uiValidate({required:true});
            $('#AcceptCustomerInformation').uiValidate({required:true});
        } else if ( options.ViewAction === 'ViewOffer' ) {
            BasketForm = ep('form#BasketOfferForm');
            BuyButton = ep("div.OrderProcessNavigation span.DoOrder button[type=submit]");
        } else {
            BasketForm = ep("form#BasketForm");
            BuyButton = ep("div.Confirm-Order button.SubmitButton");
        }

        if (BuyButton.prop("disabled")) { return; }

        BuyButton.prop("disabled", true);

        $(document).ready(function() {
            // checkoutconfirmationhelper(BasketForm, BuyButton, IsMobile)
            checkoutHelperObj = checkoutconfirmationhelper(BasketForm, BuyButton, IsMobile, options);
            // check if we come from a callback
            if (checkoutHelperObj.getUrlParameterValue('ReFrM')) {
                ep("body").busy("show");
                checkoutHelperObj.recoverMarkedCheckboxes();
                // use document element because at redirection, BasketForm selector does not work.
                document.forms[BasketForm.attr('id')].submit();
            } else {
                checkoutHelperObj.addBuyButtonClickEvent(onBuyButtonClick);
                BuyButton.prop("disabled", false);
            }
        });

        function onBuyButtonClick() {
            ep("body").busy("show");
            if (!checkoutHelperObj.validateBasketFormRequiredCheckBoxes()) {
                ep("body").busy("hide");
                return false;
            }

            var mollieOrderCreationRequestData = {
                "ChangeAction": "OrderCreationMolliePayments",
                "ObjectID": BasketId,
            };

            if (options && options.idealIssuer) {
                mollieOrderCreationRequestData["idealIssuer"] = options.idealIssuer;
            }

            if (ep('#AcceptTAC').length) {
                mollieOrderCreationRequestData["IsTacOK"] = 1;
            }

            if (ep('#AcceptCustomerInformation').length) {
                mollieOrderCreationRequestData["IsCustomerInformationOK"] = 1;
            }

            if (ep('textarea#CustomerComment').length) {
                mollieOrderCreationRequestData["CustomerComment"] = ep('textarea#CustomerComment').val();
            }

            if (ep('#IsRatingInvitationAllowed:checked').length) {
                mollieOrderCreationRequestData["IsRatingInvitationAllowed"] = ep('#IsRatingInvitationAllowed').val();
            }

            checkoutHelperObj.doRequest(mollieOrderCreationRequestData, "POST", onSuccessfulMollieOrderCreationResponse, function(){
                return function(response) {
                    checkoutHelperObj.appendErrorAndSubmitBasketForm("mollieOrderCreationRequest", response)({
                        "Name": "OrderCreation",
                        "Reason": "ConnectionError",
                    });
                }
            });
        }

        function onSuccessfulMollieOrderCreationResponse(response) {
            if (response.Error || !response.href) {
                checkoutHelperObj.appendErrorAndSubmitBasketForm("onSuccessfulMollieOrderCreationResponse", response)(response.Error);
                return;
            }

            window.location.replace(response.href);
        }

    };
});
