/*global define window*/
/*jslint browser:true*/
define([
     'testsuite/qunit',
     'testsuite/qunit-fixture!de_epages/product/ui/variationwizard-unity-test.html',
     'de_epages/product/ui/variationwizard-unity-test-helper',
     'jquery',
     'de_epages/product/ui/variationattribute-unity',
     'de_epages/product/ui/variationwizard-unity',
     'ep',

     'jquery/metaparse',
     '$ready!'
], function (QUnit, fixture1, helper, $, de_epages, ep) {
        'use strict';

    // overwrite default timeout
    window.timeoutOverwrite = 60;

    var bus = $('div'),
        options = {
            input: '.ep-variationassistant-attributevalueinput',
            initialInput: '.ep-variationassistant-attributevalueinput-initial',
            list: '.ep-variationassistant-attributelist',
            bus: $('.ep-variationassistant-attributelist').closest('form')
        },
        values;

    QUnit.module("de_epages/product/ui/variationwizard-unity'");

    QUnit.asyncTest("variationtable error test", function () {
        fixture1.init();

        var h = helper();

        window.setTimeout(function() {
            $('#Alias').val('test123').trigger('input');
            window.setTimeout(function() {
                // create two attributes with 3 values each
                h.addAttribute()(function() {
                h.addAttribute()(function() {

                h.setAlias(0, 'Attribute0')(function() {
                h.setValue(0, 0, 'value0')(function() {
                h.addValue(0, 'value1')(function() {
                h.addValue(0, 'value2')(function() {
                h.addValue(0, 'value3')(function() {

                h.setAlias(1, 'Attribute1')(function() {
                h.setValue(1, 0, 'value0')(function() {
                h.addValue(1, 'value1')(function() {
                h.addValue(1, 'value2')(function() {
                h.addValue(1, 'value3')(function() {

                // goto Step 2
                h.nextStep()(function() {
                    h.testButtons({back: [1,1], finish: [1,1]});

                    // change alias 0 , 8, 15 to same alias
                    h.setVarAlias(0, 'test1')(function() {
                    h.setVarAlias(8, 'test1')(function() {
                    h.setVarAlias(15, 'test1')(function() {

                        // expect 3 errors
                        h.testButtons({back: [1,1], finish: [0,1]});
                        QUnit.equal($('.ui-invalid').length, 3, 'three errors found');

                        h.setVarAlias(15, 'test3')(function() {
                        h.setVarAlias(8, 'test2')(function() {

                            QUnit.ok(!$('.ui-invalid').length, 'no error existing');
                            h.testButtons({back: [1,1], finish: [1,1]});

                            h.setVarAlias(3, '')(function() {
                                QUnit.equal($('.ui-invalid').length, 1, 'one error found');
                                h.testButtons({back: [1,1], finish: [0,1]});

                                h.toggleVariation(3, false)(function() {
                                    QUnit.ok(!$('.ui-invalid').length, 'no error existing');
                                    h.testButtons({back: [1,1], finish: [1,1]});

                                    h.toggleVariation(3, true)(function() {
                                        QUnit.equal($('.ui-invalid').length, 1, 'one error found');
                                        h.testButtons({back: [1,1], finish: [0,1]});

                                        fixture1.destroy();
                                        QUnit.start();
                                    });
                                });
                            });

                        });
                        });

                    });
                    });
                    });

                });

                });
                });
                });
                });
                });

                });
                });
                });
                });
                });

                });
                });
            }, 300);
        }, 1000);
    });

    QUnit.asyncTest("variationtable mass test", function () {
        fixture1.init();

        var h = helper();

        window.setTimeout(function() {
            $('#Alias').val('test123').trigger('input');

            window.setTimeout(function() {

                h.addAttribute()(function() {
                h.addAttribute()(function() {
                h.addAttribute()(function() {

                h.setAlias(0, 'Attribute0')(function() {
                h.setValue(0, 0, 'value0')(function() {
                h.addValue(0, 'value1')(function() {
                h.addValue(0, 'value2')(function() {

                h.setAlias(1, 'Attribute1')(function() {
                h.setValue(1, 0, 'value0')(function() {
                h.addValue(1, 'value1')(function() {
                h.addValue(1, 'value2')(function() {
                h.addValue(1, 'value3')(function() {
                h.addValue(1, 'value4')(function() {
                h.addValue(1, 'value5')(function() {
                h.addValue(1, 'value6')(function() {
                h.addValue(1, 'value7')(function() {
                h.addValue(1, 'value8')(function() {
                h.addValue(1, 'value9')(function() {

                h.setAlias(2, 'Attribute2')(function() {
                h.setValue(2, 0, 'value0')(function() {
                h.addValue(2, 'value1')(function() {
                h.addValue(2, 'value2')(function() {
                h.addValue(2, 'value3')(function() {
                h.addValue(2, 'value4')(function() {
                h.addValue(2, 'value5')(function() {
                h.addValue(2, 'value6')(function() {


                h.testButtons({next: [0, 1]});

                h.setSelectionStateAttributeValue(2, 6, false)(function() {

                    h.testButtons({next: [1, 1]});
                    h.nextStep()(function() {
                        h.testButtons({back: [1,1], finish: [1,1]});

                        fixture1.destroy();
                        QUnit.start();
                    });

                });

                });
                });
                });
                });
                });
                });
                });
                });

                });
                });
                });
                });
                });
                });
                });
                });
                });
                });
                });

                });
                });
                });
                });

                });
                });
                });
            }, 300);
        }, 1000);
    });

});